Bug 1758619 (CVE-2019-16869)

Summary: CVE-2019-16869 netty: HTTP request smuggling by mishandled whitespace before the colon in HTTP headers
Product: [Other] Security Response Reporter: Jonathan Christison <jochrist>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: CLOSED ERRATA QA Contact:
Severity: high Docs Contact:
Priority: high    
Version: unspecifiedCC: aileenc, akoufoud, alazarot, almorale, anstephe, aos-bugs, asoldano, atangrin, ataylor, avibelli, bbaranow, bbuckingham, bcourt, bgeorges, bkearney, bmaxwell, bmontgom, brian.stansberry, btotty, cdewolf, chazlett, darran.lofthouse, dosoudil, drieden, eparis, etirelli, ganandan, ggaughan, hhudgeon, ibek, iweiss, janstey, jawilson, jbalunas, jburrell, jcantril, jochrist, jokerman, jpallich, jperkins, jross, jstastny, krathod, kverlaen, kwills, lgao, lthon, lzap, mmccune, mnovotny, msochure, msvehla, mszynkie, nstielau, nwallace, paradhya, pdrozd, pgallagh, pmackay, psotirop, rchan, rguimara, rjerrido, rrajasek, rruss, rsvoboda, rsynek, sdaley, smaestri, sokeeffe, sponnaga, sthorger, tbrisker, tom.jenkinson, twalsh
Target Milestone: ---Keywords: Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: netty 4.1.42.Final Doc Type: If docs needed, set a value
Doc Text:
A flaw was found in Netty, where whitespace before the colon in HTTP headers is mishandled. This flaw allows an attacker to cause HTTP request smuggling.
Story Points: ---
Clone Of: Environment:
Last Closed: 2019-11-15 00:51:24 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Bug Depends On: 1796325, 1796326, 1796327, 1796328, 1796329, 1797640, 1797641, 1797642, 1825805    
Bug Blocks: 1758604    

Description Jonathan Christison 2019-10-04 15:50:39 UTC
Netty before 4.1.42.Final mishandles whitespace before the colon in HTTP headers (such as a "Transfer-Encoding : chunked" line), which leads to HTTP request smuggling.

References:

Upstream bug:
https://github.com/netty/netty/issues/9571
 
Upstream commit:
https://github.com/netty/netty/commit/39cafcb05c99f2aa9fce7e6597664c9ed6a63a95

Fixed upstream in version 4.1.42.Final:
https://netty.io/news/2019/09/25/4-1-42-Final.html

Comment 8 errata-xmlrpc 2019-11-14 21:18:46 UTC
This issue has been addressed in the following products:

  Red Hat Fuse 7.5.0

Via RHSA-2019:3892 https://access.redhat.com/errata/RHSA-2019:3892

Comment 9 Product Security DevOps Team 2019-11-15 00:51:24 UTC
This bug is now closed. Further updates for individual products will be reflected on the CVE page(s):

https://access.redhat.com/security/cve/cve-2019-16869

Comment 11 errata-xmlrpc 2019-11-18 14:41:11 UTC
This issue has been addressed in the following products:

  Red Hat Openshift Application Runtimes Vert.x 3.8.3

Via RHSA-2019:3901 https://access.redhat.com/errata/RHSA-2019:3901

Comment 14 errata-xmlrpc 2020-01-21 02:24:04 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform

Via RHSA-2020:0164 https://access.redhat.com/errata/RHSA-2020:0164

Comment 15 errata-xmlrpc 2020-01-21 02:56:34 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 7.2 for RHEL 6

Via RHSA-2020:0159 https://access.redhat.com/errata/RHSA-2020:0159

Comment 16 errata-xmlrpc 2020-01-21 03:21:56 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 7.2 for RHEL 8

Via RHSA-2020:0161 https://access.redhat.com/errata/RHSA-2020:0161

Comment 17 errata-xmlrpc 2020-01-21 03:46:44 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 7.2 for RHEL 7

Via RHSA-2020:0160 https://access.redhat.com/errata/RHSA-2020:0160

Comment 18 Jonathan Christison 2020-01-24 10:58:14 UTC
Mitigation:

* Use HTTP/2 instead (clear boundaries between requests)
* Disable reuse of backend connections eg. ```http-reuse never``` in HAProxy or whatever equivalent LB settings

Comment 23 Yadnyawalk Tale 2020-02-04 05:23:38 UTC
Statement:

OpenShift Container Platform ships a vulnerable netty library as part of the logging-elasticsearch5 container. ElasticSearch's security team has stated that this vulnerability does not poses a substantial practical threat to ElasticSearch 6 [1]. We agree that this issue would be difficult to exploit these vulnerabilities on OpenShift Container Platform, so we're reducing the impact of this issue to moderate and may fix it in the future release.

Red Hat Satellite ships vulnerable netty version embedded in Candlepin, however, is not directly vulnerable since HTTP requests are handled by Tomcat and not netty.

[1]  https://github.com/elastic/elasticsearch/issues/49396

Comment 24 errata-xmlrpc 2020-02-06 08:36:07 UTC
This issue has been addressed in the following products:

  Red Hat Single Sign-On

Via RHSA-2020:0445 https://access.redhat.com/errata/RHSA-2020:0445

Comment 31 errata-xmlrpc 2020-03-23 08:22:58 UTC
This issue has been addressed in the following products:

  Red Hat AMQ

Via RHSA-2020:0922 https://access.redhat.com/errata/RHSA-2020:0922

Comment 32 errata-xmlrpc 2020-04-14 13:05:26 UTC
This issue has been addressed in the following products:

  Red Hat AMQ 7.4.3

Via RHSA-2020:1445 https://access.redhat.com/errata/RHSA-2020:1445

Comment 34 errata-xmlrpc 2020-05-26 16:09:45 UTC
This issue has been addressed in the following products:

  Red Hat Data Grid 7.3.6

Via RHSA-2020:2321 https://access.redhat.com/errata/RHSA-2020:2321